! file gscurrsession_2.gs
!  $Id$
!===================================================================================

! fixed 42355 , 46813
category: 'Initialization'
method: GsCurrentSession
initialize

" This method is executed once at Session initialization,
  after the ProcessorScheduler is initialized.  It is invoked from
  ProcessorScheduler >> _initialize . 

  To install application specific initialization code, 
  use UserProfile>>loginHook: .

  Deprecated behavior: 
    This method may be modified to invoke application specific 
    initialization code.  

    Use extreme caution when testing modifications to this method.
    Errors in this method may unrecoverably disable commits and
    require restore from backup.  Prior to testing modifications,
    make a full backup of your system.  During testing, disable
    execution of application specific code for user SystemUser to
    allow recovery.
"
"Globals at: #IcuLibraryVersion checks are now done in C
 during VM initialization.  The value of IcuLibraryVersion determines
 the version of the libicu libraries loaded by the VM.
 On AIX to use an older version of the libicu libraries
 you must also modify $GEMSTONE/lib , for example to use version 51.2
    cd $GEMSTONE/lib ; chmod +w .
    mv libicudata.54.1.so libicudata.54.1.so.save
    ln -s libicudata.51.2.so libicudata.54.1.so
    mv libicui18n.54.1.so libicui18n.54.1.so.save
    ln -s libicui18n.51.2.so libicui18n.54.1.so
    mv libicuuc.54.1.so libicuuc.54.1.so.save
    ln -s libicuuc.51.2.so libicuuc.54.1.so
 The association (Globals associationAt: #IcuLibraryVersion) is
 owned by SystemUser; its value should only be changed by SystemUser
 when no other user sessions are logged in, after which stone must
 be shutdown and restarted.
"

"install a sessionMethodDictionary if GsPackagePolicy is enabled"
GsPackagePolicy enabled
  ifTrue:[ GsPackagePolicy loadSessionMethodDictionary ]
  ifFalse:[ Unicode16 installUnicodeComparePrimitives ].

"invoke the  method or block specified by  UserProfile >> loginHook: "
userProfile _postLoginInitialize .

^ self
%


